regina::NPlugTriSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents a plugged triangular solid torus component of a triangulation. More...

`#include <subcomplex/nplugtrisolidtorus.h>`

Inheritance diagram for regina::NPlugTriSolidTorus:

## Public Member Functions

virtual | ~NPlugTriSolidTorus ()
| Destroys this plugged solid torus; note that the corresponding triangular solid torus and layered chains will also be destroyed. More...
NPlugTriSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
const NTriSolidTorus & | getCore () const
| Returns the triangular solid torus at the core of this triangulation. More...
const NLayeredChain * | getChain (int annulus) const
| Returns the layered chain attached to the requested annulus on the boundary of the core triangular solid torus. More...
int | getChainType (int annulus) const
| Returns the way in which a layered chain is attached to the requested annulus on the boundary of the core triangular solid torus. More...
int | getEquatorType () const
| Returns which types of edges form the equator of the plug. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NPlugTriSolidTorus * | isPlugTriSolidTorus (NComponent *comp)
| Determines if the given triangulation component is a plugged triangular solid torus. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Static Public Attributes

static const int | CHAIN_NONE
| Indicates an annulus on the triangular solid torus boundary with no attached layered chain. More...
static const int | CHAIN_MAJOR
| Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the major edge of the annulus. More...
static const int | CHAIN_MINOR
| Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the minor edge of the annulus. More...
static const int | EQUATOR_MAJOR
| Indicates that, if no layered chains were present, the equator of the plug would consist of major edges of the core triangular solid torus. More...
static const int | EQUATOR_MINOR
| Indicates that, if no layered chains were present, the equator of the plug would consist of minor edges of the core triangular solid torus. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a plugged triangular solid torus component of a triangulation.

Such a component is obtained as follows.

Begin with a three-tetrahedron triangular solid torus (as described by class NTriSolidTorus). Observe that the three axis edges divide the boundary into three annuli.

To each of these annuli a layered chain may be optionally attached. If present, the chain should be attached so its hinge edges are identified with the axis edges of the corresonding annulus and its bottom tetrahedron is layered over either the major edge or minor edge of the corresponding annulus. The top two triangular faces of the layered chain should remain free.

Thus we now have three annuli on the boundary, each represented as a square two of whose (opposite) edges are axis edges of the original triangular solid torus (and possibly also hinge edges of a layered chain).

Create a plug by gluing two tetrahedra together along a single triangle. The six edges that do not run along this common triangle split the plug boundary into three squares. These three squares must be glued to the three boundary annuli previously described. Each axis edge meets two of the annuli; the two corresponding edges of the plug must be non-adjacent (have no common vertex) on the plug. In this way each of the six edges of the plug not running along its interior triangle corresponds to precisely one of the two instances of precisely one of the three axis edges.

If the axis edges are directed so that they all point the same way around the triangular solid torus, these axis edges when drawn on the plug must all point from one common tip of the plug to the other (where the tips of the plug are the vertices not meeting the interior triangle). The gluings must also be made so that the resulting triangulation component is orientable.

Of the optional NStandardTriangulation routines, getManifold() is implemented for most plugged triangular solid tori and getHomologyH1() is not implemented at all.

Test:
  Included in the test suite.

## Constructor & Destructor Documentation

virtual regina::NPlugTriSolidTorus::~NPlugTriSolidTorus | ( |  | ) |

virtual

Destroys this plugged solid torus; note that the corresponding triangular solid torus and layered chains will also be destroyed.

## Member Function Documentation

NPlugTriSolidTorus* regina::NPlugTriSolidTorus::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

const NLayeredChain * regina::NPlugTriSolidTorus::getChain | ( | int | annulus | ) | const

inline

Returns the layered chain attached to the requested annulus on the boundary of the core triangular solid torus.

If there is no attached layered chain, `null` will be returned.

Note that the core triangular solid torus will be attached to the bottom (as opposed to the top) of the layered chain.

Parameters

  annulus | specifies which annulus to examine; this must be 0, 1 or 2.

Returns
  the corresponding layered chain.

int regina::NPlugTriSolidTorus::getChainType | ( | int | annulus | ) | const

inline

Returns the way in which a layered chain is attached to the requested annulus on the boundary of the core triangular solid torus.

This will be one of the chain type constants defined in this class.

Parameters

  annulus | specifies which annulus to examine; this must be 0, 1 or 2.

Returns
  the type of layered chain, or CHAIN_NONE if there is no layered chain attached to the requested annulus.

const NTriSolidTorus & regina::NPlugTriSolidTorus::getCore | ( |  | ) | const

inline

Returns the triangular solid torus at the core of this triangulation.

Returns
  the core triangular solid torus.

int regina::NPlugTriSolidTorus::getEquatorType | ( |  | ) | const

inline

Returns which types of edges form the equator of the plug.

In the absence of layered chains these will either all be major edges or all be minor edges.

Layered chains complicate matters, but the roles that the major and minor edges play on the boundary annuli of the triangular solid torus can be carried up to the annuli at the top of each layered chain; the edges filling the corresponding major or minor roles will then form the equator of the plug.

Returns
  the types of edges that form the equator of the plug; this will be one of the equator type constants defined in this class.

NManifold* regina::NPlugTriSolidTorus::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

static NPlugTriSolidTorus* regina::NPlugTriSolidTorus::isPlugTriSolidTorus | ( | NComponent * | comp | ) |

static

Determines if the given triangulation component is a plugged triangular solid torus.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the plugged triangular solid torus, or `null` if the given component is not a plugged triangular solid torus.

std::ostream& regina::NPlugTriSolidTorus::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream& regina::NPlugTriSolidTorus::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NPlugTriSolidTorus::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

## Member Data Documentation

const int regina::NPlugTriSolidTorus::CHAIN_MAJOR

static

Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the major edge of the annulus.

const int regina::NPlugTriSolidTorus::CHAIN_MINOR

static

Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the minor edge of the annulus.

const int regina::NPlugTriSolidTorus::CHAIN_NONE

static

Indicates an annulus on the triangular solid torus boundary with no attached layered chain.

const int regina::NPlugTriSolidTorus::EQUATOR_MAJOR

static

Indicates that, if no layered chains were present, the equator of the plug would consist of major edges of the core triangular solid torus.

const int regina::NPlugTriSolidTorus::EQUATOR_MINOR

static

Indicates that, if no layered chains were present, the equator of the plug would consist of minor edges of the core triangular solid torus.

The documentation for this class was generated from the following file:

- subcomplex/nplugtrisolidtorus.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).